# -*- coding: utf-8 -*-
def display_as_tree(lst, i=0, indent_root="", indent_others="    "):
    """Display a list as a binary tree.

    :param lst: A list.
    :param i: An integer. The index of the root node to consider.
    :param indent_root: A string to be printed before the root.
    :param indent_others: A string to be printed before its children.

    The list lst is considered as a binary tree, where the children of
    element lst[k] are lst[2 * k + 1] and lst[2 * k + 2] (if they exist).
    """
    if i >= len(lst):
        return
    print(indent_root + "|-> " + str(lst[i]))
    display_as_tree(lst, 2 * i + 1, indent_root=indent_others,
                    indent_others=indent_others + "|   ")
    display_as_tree(lst, 2 * i + 2, indent_root=indent_others,
                    indent_others=indent_others + "    ")


if __name__ == "__main__":

    A = [4, 1, 3, 8, 2, 0, 5, 6, 9, 7]
    print(A)
    display_as_tree(A)